/* 

   this file has define that generate prototypes for 
   a generic linked list LISTTYPE of ELEMENTS

   methods                  macro

   new_P                    P_NEWLIST(LISTTYPE)
   delete_P                   P_FREELIST(LISTTYPE)
   print_P                  P_PRINTLIST(LISTTYPE)
   clean_P                  P_CLEANLIST(LISTTYPE, ELEMENT)
   cat_P                    P_CATLIST(LISTTYPE, ELEMENT)
   test_P                   P_TESTLIST(LISTTYPE, ELEMENT)
   add_E                    P_ADDELEMENT(LISTTYPE, ELEMENT)
   remove_E                 P_REMOVEELEMENT(LISTTYPE, ELEMENT) 
   in_P                     P_INLIST(LISTTYPE, ELEMENT) 


  (C) 1997 Marco Falcioni (falcioni@ucla.edu)

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
  USA.

  http://www.fsf.org/copyleft/gpl.html


*/

#define P_NEWLIST(LISTTYPE)    struct LISTTYPE * new_ ##LISTTYPE (void);
#define P_FREELIST(LISTTYPE)   void delete_ ##LISTTYPE (struct LISTTYPE * This);
#define P_PRINTLIST(LISTTYPE)  void print_ ##LISTTYPE (const struct LISTTYPE * LISTTYPE, FILE * stream);
#define P_CLEANLIST(LISTTYPE)  void clean_ ##LISTTYPE (struct LISTTYPE * a);
#define P_CATLIST(LISTTYPE)    struct LISTTYPE * cat_ ##LISTTYPE (struct LISTTYPE * a, struct LISTTYPE * b);
#define P_TESTLIST(LISTTYPE)               void test_ ##LISTTYPE (const struct LISTTYPE * a, FILE * stream);
#define P_ADDELEMENT(LISTTYPE, ELEMENT)    void add_ ##ELEMENT (struct ELEMENT * me, struct LISTTYPE * to_me);
#define P_ADDELEMENTCHK(LISTTYPE, ELEMENT)    void add_ck_ ##ELEMENT (struct ELEMENT * me, struct LISTTYPE * to_me);
#define P_REMOVEELEMENT(LISTTYPE, ELEMENT) void remove_ ##ELEMENT (struct ELEMENT * me, struct LISTTYPE * from_me);
#define P_INLIST(LISTTYPE, ELEMENT)        int in_ ##LISTTYPE (struct ELEMENT * me, struct LISTTYPE * in_me);
#define P_SORTLIST(LISTTYPE, ELEMENT)        void sort_ ##LISTTYPE (struct LISTTYPE * me);

