/* Created: [GJ] Mon Feb 10 08:33:27 EST 1997
 *
 * [GJ] Wed Apr 16 19:17:44 EDT 1997
 * Removed obsolete code. Removed Malloc() and Free() macros.
 */
#include <stdio.h>
#include <stdlib.h>
#include "memory.h"
#include "error.h"

/* Never know where the stuff is hiding.
 * Better safe than sorry on most systems.
 * Everybody has to have these... right?
 */
#include <stddef.h>
#include <stdlib.h>
#ifdef __alpha
/*
 * No known problem with Alpha/OSF1.
 */
#include <malloc.h>
#endif
#ifdef __aix
/*
 * No known problem with rs6000/AIX.
 */
#include <malloc.h>
#endif
#ifdef __next
/*
 * No known extra requirements for Next.
 * However, we cannot include malloc.h on the Next,
 * because it is missing...
 */
#endif
#include <malloc.h>

/* yibdee bibdee pazulaboo... */
#define GEN_ALLOC(FUNC, TYPE)                                         \
TYPE * FUNC(unsigned long size)                                       \
{                                                                     \
  TYPE * p = (TYPE *) malloc((size_t)(size * sizeof(TYPE)));          \
  if(p == 0) {                                                        \
    char buff[1024];                                                   \
    sprintf(buff,"FUNC: alloc of size %ld failed", size);             \
    push_error(buff, Error_Alloc_);                                   \
  }                                                                   \
  return p;                                                           \
}                                                                     \

GEN_ALLOC(new_vector_i, int)
GEN_ALLOC(new_vector_l, long)
GEN_ALLOC(new_vector_d, double)
GEN_ALLOC(new_vector_f, float)
GEN_ALLOC(new_vector_c, char)

GEN_ALLOC(new_vector_ip, int *)
GEN_ALLOC(new_vector_lp, long *)
GEN_ALLOC(new_vector_dp, double *)
GEN_ALLOC(new_vector_fp, float *)
GEN_ALLOC(new_vector_cp, char *)


void free_vector(void * p)
{
  if(p != 0) free(p);
}


/* yibdee bibdee pazulaboo indeed... */
#define GEN_MATALLOC(FUNC, PALC, ALC, TYPE)                           \
TYPE ** FUNC(unsigned long size)                                      \
{                                                                     \
  TYPE ** m = PALC(size);                                             \
  if(m == 0) {                                                        \
    char buff[1024];                                                   \
    sprintf(buff,"FUNC: alloc of size %ld failed", size);             \
    push_error(buff, Error_Alloc_);                                   \
    return 0;                                                         \
  }                                                                   \
  else {                                                              \
    unsigned long i;                                                  \
    for(i=0; i<size; i++) {                                           \
      m[i] = ALC(size);                                               \
    }                                                                 \
    return m;                                                         \
  }                                                                   \
}                                                                     \

#define GEN_MATFREE(FUNC, TYPE)                                     \
void FUNC(TYPE ** m, unsigned long size)                            \
{                                                                   \
  unsigned long i;                                                  \
  if(m != 0) {                                                      \
    for(i=0; i<size; i++) {                                         \
      if(m[i] != 0) free_vector(m[i]);                              \
    }                                                               \
    free_vector(m);                                                 \
  }                                                                 \
}                                                                   \


GEN_MATALLOC(new_matrix_i, new_vector_ip, new_vector_i, int)
GEN_MATALLOC(new_matrix_l, new_vector_lp, new_vector_l, long)
GEN_MATALLOC(new_matrix_d, new_vector_dp, new_vector_d, double)
GEN_MATALLOC(new_matrix_f, new_vector_fp, new_vector_f, float)

GEN_MATFREE(free_matrix_i, int)
GEN_MATFREE(free_matrix_l, long)
GEN_MATFREE(free_matrix_d, double)
GEN_MATFREE(free_matrix_f, float)


#define GEN_COPYVEC(FUNC, ALLOC, TYPE)                              \
TYPE * FUNC(TYPE * v, unsigned long size)                           \
{                                                                   \
  if(v != 0) {                                                      \
    TYPE * nv = ALLOC(size);                                        \
    if(nv==0) return 0;                                             \
    memcpy(nv, v, size*sizeof(TYPE));                               \
    return nv;                                                      \
  }                                                                 \
  else {                                                            \
    return 0;                                                       \
  }                                                                 \
}                                                                   \

GEN_COPYVEC(copy_vector_i, new_vector_i, int)
GEN_COPYVEC(copy_vector_l, new_vector_l, long)
GEN_COPYVEC(copy_vector_d, new_vector_d, double)
GEN_COPYVEC(copy_vector_f, new_vector_f, float)
GEN_COPYVEC(copy_vector_c, new_vector_c, char)



#define GEN_COPYMAT(FUNC, ALLOC, COPYVEC, TYPE)                     \
TYPE ** FUNC(TYPE ** m, unsigned long size)                         \
{                                                                   \
  if(m != 0) {                                                      \
    unsigned long i;                                                \
    TYPE ** nm = ALLOC(size);                                       \
    if(nm==0) return 0;                                             \
    for(i=0; i<size; i++) {                                         \
      nm[i] = COPYVEC(m[i], size);                                  \
    }                                                               \
    return nm;                                                      \
  }                                                                 \
  else {                                                            \
    return 0;                                                       \
  }                                                                 \
}                                                                   \

GEN_COPYMAT(copy_matrix_i, new_matrix_i, copy_vector_i, int)
GEN_COPYMAT(copy_matrix_l, new_matrix_l, copy_vector_l, long)
GEN_COPYMAT(copy_matrix_d, new_matrix_d, copy_vector_d, double)
GEN_COPYMAT(copy_matrix_f, new_matrix_f, copy_vector_f, float)
