/* Created: [GJ] Fri Jan 17 17:18:43 EST 1997
 */
#include "sorting.h"


double maxReal(const double * v, unsigned long size)
{
  if(size == 0) {
    return 0; /* this is clearly not the answer... */
  }
  else {
    double max = v[0];
    unsigned long i;
    for(i=0; i<size; i++) max = Max(max, v[i]);
    return max;
  }
}

double minReal(const double * v, unsigned long size)
{
  if(size == 0) {
    return 0; /* this is clearly not the answer... */
  }
  else {
    double min = v[0];
    unsigned long i;
    for(i=0; i<size; i++) min = Min(min, v[i]);
    return min;
  }
}

void minmaxReal(const double * v, unsigned long size, double * min, double * max)
{
  if(size == 0) {
    /* this is clearly not the answer... */
    *min = 0.;
    *max = 0.;
    return;
  }
  else {
    unsigned long i;
    *max = v[0];
    *min = v[0];
    for(i = 0; i<size; i++){
      *max = Max(*max, v[i]);
      *min = Min(*min, v[i]);
    }
    return;
  }
}


int maxInt(const int * v, unsigned long size)
{
  if(size == 0) {
    return 0; /* this is clearly not the answer... */
  }
  else {
    int max = v[0];
    unsigned long i;
    for(i=0; i<size; i++) max = Max(max, v[i]);
    return max;
  }
}

int minInt(const int * v, unsigned long size)
{
  if(size == 0) {
    return 0; /* this is clearly not the answer... */
  }
  else {
    int min = v[0];
    unsigned long i;
    for(i=0; i<size; i++) min = Min(min, v[i]);
    return min;
  }
}

void minmaxInt(const int * v, unsigned long size, int * min, int * max)
{
  if(size == 0) {
    /* this is clearly not the answer... */
    *min = 0;
    *max = 0;
    return;
  }
  else {
    unsigned long i;
    *max = v[0];
    *min = v[0];
    for(i = 0; i<size; i++){
      *max = Max(*max, v[i]);
      *min = Min(*min, v[i]);
    }
    return;
  }
}


void heapsortReal(double * vec, unsigned long size)
{
  unsigned long i;
  unsigned long j;
  unsigned long ell = (size >> 1);
  unsigned long ir = size - 1;
  double temp_x;

  if(size <= 1) return;

  for (;;) {
    if (ell > 0)
      {
        --ell;
        temp_x = vec[ell];
      }
    else
      {
        temp_x = vec[ir];
        vec[ir] = vec[0];
        --ir;
        if(ir == 0)
          {
            vec[0] = temp_x;
            break;
          }
      }
    i = ell;
    j = ell + ell + 1;
    while (j <= ir) {
      if(j < ir && (vec[j] < vec[j+1])) j++;
      if(temp_x < vec[j])
        {
          vec[i] = vec[j];
          i = j;
          j = 2 * j + 1;
        }
      else j = ir+1;
    }
    vec[i] = temp_x;
  }
}


void heapsortInt(int * vec, unsigned long size)
{
  unsigned long i;
  unsigned long j;
  unsigned long ell = (size >> 1);
  unsigned long ir = size - 1;
  int temp_x;

  if(size <= 1) return;

  for (;;) {
    if (ell > 0)
      {
        --ell;
        temp_x = vec[ell];
      }
    else
      {
        temp_x = vec[ir];
        vec[ir] = vec[0];
        --ir;
        if(ir == 0)
          {
            vec[0] = temp_x;
            break;
          }
      }
    i = ell;
    j = ell + ell + 1;
    while (j <= ir) {
      if(j < ir && (vec[j] < vec[j+1])) j++;
      if(temp_x < vec[j])
        {
          vec[i] = vec[j];
          i = j;
          j = 2 * j + 1;
        }
      else j = ir+1;
    }
    vec[i] = temp_x;
  }
}


void heapsortmapReal(double * v, unsigned long size, unsigned long * map)
{
  unsigned long i;
  unsigned long j;
  unsigned long maptemp;
  unsigned long ell = (size >> 1);
  unsigned long ir = size - 1;
  double temp_x;

  /* Prepare the initial map. */
  for(i = 0; i<size; i++) map[i] = i;

  if(size <= 1) return;

  for (;;) {
    if (ell > 0)
      {
        --ell;
        temp_x = v[map[ell]];
        maptemp = map[ell];
      }
    else
      {
        temp_x = v[map[ir]];
        maptemp = map[ir];
        map[ir] = map[0];
        --ir;
        if(ir == 0)
          {
            map[0] = maptemp;
            break;
          }
      }
    i = ell;
    j = ell + ell + 1;
    while (j <= ir) {
      if(j < ir && (v[map[j]] < v[map[j+1]])) j++;
      if(temp_x < v[map[j]])
        {
          map[i] = map[j];
	  i = j;
          j = 2 * j + 1;
        }
      else j = ir+1;
    }
    map[i] = maptemp;
  }
}


void heapsortmapInt(int v[], unsigned long size, unsigned long * map)
{
  unsigned long i;
  unsigned long j;
  unsigned long maptemp;
  unsigned long ell = (size >> 1);
  unsigned long ir = size - 1;
  int temp_x;

  /* Prepare the initial map. */
  for(i=0; i<size; i++) map[i] = i;

  if(size <= 1) return;

  for (;;) {
    if (ell > 0)
      {
        --ell;
        temp_x = v[map[ell]];
        maptemp = map[ell];
      }
    else
      {
        temp_x = v[map[ir]];
        maptemp = map[ir];
        map[ir] = map[0];
        --ir;
        if(ir == 0)
          {
            map[0] = maptemp;
            break;
          }
      }
    i = ell;
    j = ell + ell + 1;
    while (j <= ir) {
      if(j < ir && (v[map[j]] < v[map[j+1]])) j++;
      if(temp_x < v[map[j]])
        {
          map[i] = map[j];
	  i = j;
          j = 2 * j + 1;
        }
      else j = ir+1;
    }
    map[i] = maptemp;
  }
}
