/*

  test the spline code of GJ

  (C) 1997 Marco Falcioni (falcioni@ucla.edu)

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
  USA.

  http://www.fsf.org/copyleft/gpl.html

*/

#include <stdio.h>
#include "interpolation.h"
#include "error.h"
#include "resources.h"
#include "stringlib.h"
#include "spline.h"
#include "misc.h"

int main (int argc, char * argv[])
{
  char * name;
  struct Spline * S;
  struct string_list * options;

  connect_error_stream(stderr, argv[0]);

  options = append_string_to_list(0, "v");

  args_to_resources(argc, argv, options);

  if(extract_global_resource("v")) connect_verbose_stream(stderr, argv[0]);

  if(!argc) {
    push_generic_error("spline_to_xy","Usage: spline_to_xy file");
    exit(1);
  }

  name = argv[1];

  S =  read_Spline(name);

  write_Spline(S,stdout);

  return 0;

}
