/*

  Marco Falcioni (C) 1997

  powder diffraction data:  spot

*/

#ifndef __spot_h
#define __spot_h

/* includes */
#include <stdio.h>
#include "misc.h"

enum Rad_type;
struct Intensity;

struct Spot {
  double h_,k_,l_;
  double twotheta;
  unsigned multiplicity;
  struct Intensity * xray;
  struct Intensity * neutron;
};

/* function prototypes */


struct Spot * new_Spot(enum Rad_type a);
void delete_Spot(struct Spot * me);
void print_Spot(const struct Spot * me, FILE * stream);

void copy_Spot(const struct Spot * me, struct Spot * to_me);

/* makes a new spot if me == 0 */
struct Spot * read_Spot(struct Spot * me, const char * string, 
			enum Rad_type a);


#endif
