/*

  simulated annealing with simple monte carlo

 (C) 1997 Marco Falcioni (falcioni@ucla.edu)

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
  USA.

  http://www.fsf.org/copyleft/gpl.html
*/


#include <stdio.h>
#include <stdlib.h>

#include "misc.h"
#include "functions.h"
#include "error.h"
#include "grid.h"
#include "chain.h"
#include "link.h"
#include "atoms.h"
#include "spline.h"
#include "params.h"
#include "rad_pattern.h"
#include "oogl.h"
#include "positions.h"
#include "verbose.h"

int main (int argc, char ** argv)
{
  struct Params * P = 0;
  struct Cell * C = 0;
  struct Positions * T = 0;
  struct Sym_group * G = 0;
  struct Rad_pattern * RP = 0;
  FILE * verb;

  verb = safe_open("messages","w");

  connect_error_stream(stderr, argv[0]);
  connect_verbose_stream(verb, argv[0]);
  
  read_data(&P, &T, &C, &G, &RP, stdin);

  srand48(P->seed);

  anneal(P, C, G, RP, T);

  return 0;
  
}

