/*

  ZEFSA II
  Marco Falcioni (C) 1999

  (C) 1999 Marco Falcioni (falcioni@ucla.edu)

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
  USA.

  http://www.fsf.org/copyleft/gpl.html

*/

#ifndef __vector_h
#define __vector_h

#include <stdio.h>

void scale_vector(double * a, double b, int size);
void cross_product(const double * a, const double * b, double * c);
void add_vectors(const double * a, const double * b, double * c, double m, int size);
double norm2_vector(const double * a, int size);
/* random orientation on unit sphere */
void ranor( double * a );
double * copy_vector(double * a, const double * b, int size);
void rotate_vector(const double * a, const double * n, double * ret, 
		double cost, double sint);
#endif /* _vector_h */
